/* this should be the device id (2 for keyboard, 3 for mouse, etc) << 4 */
#define MYDEVID 0x30

#define kADBPin GPIO_Pin_6
#define kADBSensePin GPIO_Pin_3
#define kADBPowerPin GPIO_Pin_4

#define kADBStateIdle 1
#define kADBStateAttn 2
#define kADBStateSync 3
#define kADBStateReadCmdBitLow 4
#define kADBStateReadCmdBitHigh 5
#define kADBStateStopLow 6
#define kADBStateReadDataBitLow 7
#define kADBStateReadDataBitHigh 8
#define kADBStateWriteDataBitLow 9
#define kADBStateWriteDataBitHigh 10
#define kADBStateWriteStop 11
#define kADBStateStopStart 12
#define kADBStateWriteStartBitLow 13
#define kADBStateWriteStartBitHigh 14
#define kADBStateSignalRequest 15

#define kADBBuffSize 32

#define kModCmd      1
#define kModOpt      2
#define kModShift    4
#define kModControl  8
#define kModReset   16
#define kModCaps    32
#define kModDelete  64

struct adbdevice {
	uint8_t devid;
	uint16_t reg0;
	uint16_t reg1;
	uint16_t reg2;
	uint16_t reg3;
};

struct adb {
	uint8_t state;
	int16_t bit;
	uint8_t curticks;
	uint8_t cmd;
	uint16_t senddata;
	uint16_t activedevs;
	struct adbdevice device[16];
};


void ADBTick_Handler(void);
void ADBInit(void);
void ADBSendMouse(uint8_t ps2status, uint8_t ps2xmove, uint8_t ps2ymove);
void ADBPowerSet(void);
void ADBPowerReset(void);

